%% All param
FilterSamplesSizes={5;20;40}
ovarlapPctBucket={25;50}
for zeta=1:14
for myfilter=1:2    
for alpha=1:length(FilterSamplesSizes)    
for beta=1:length(ovarlapPctBucket)
    
Paras={'age';'sex';'cp';'trestbps';'chol';'fbs';'restecg';'thalach';'exang';'oldpeak';'slope';'ca';'thal';'survival'}

%% Generate a matrix from heart dataset
X = csvread('data.csv');
 
%% Find the Inter-point Distance Matrix

%% Find the filter, here we use the distance from the first point
if(myfilter==1)
    d = L2_distance(X',X',1);
    eccFilter = X(:, zeta);
    filtername='L2';

else
    d = corr(X');    
    eccFilter = X(:, zeta);
    filtername='Pearson';
end
scatter(X(:,1), X(:,2), 1000, eccFilter, '.');
axis equal;

%% Parameters for Mapper
filterSamples = FilterSamplesSizes{alpha};
overlapPct = ovarlapPctBucket{beta};

%% Run Mapper
[adja, nodeInfo, levelIdx] = mapper(d, eccFilter, 1/filterSamples,...
                                                        overlapPct);
                                         
%% Prepare inputs for GraphViz
% For each node of the output graph, find the size (~ cardinality of the
% cluster) and the average function value of points in the cluster.
label{1} = sprintf('Dataset Name   : test');
label{2} = sprintf('Filter Samples : %d', filterSamples);
label{3} = sprintf('Overlap Pct    : %0.2f', overlapPct);

for i=1:length(nodeInfo)
    ecc(i) = nodeInfo{i}.filter;    
    setSize(i) = length(nodeInfo{i}.set);
    z=i
    a = nodeInfo{i}.set
end

%% Generate the input to Graphviz
writeDotFile(sprintf('/media/deepak/extension/matlab/tda/matlab_examples/mapper/t1.dot'), adja, ecc, setSize, label);

%% Execute Graphviz
filterstr=sprintf('%s_%s',Paras{zeta},filtername);
fname=sprintf('%s_%d_%d.png',filterstr,filterSamples,overlapPct)

filterdir=sprintf('heart_data_mapper_images_point/%s',filtername);
mkdir(filterdir)
paramdir=sprintf('heart_data_mapper_images_point/%s/%s',filtername,Paras{zeta});
mkdir(paramdir)
commd=sprintf('/usr/bin/neato -Tpng t1.dot -o heart_data_mapper_images_point/%s/%s/%s',filtername,Paras{zeta},fname);
file_with_location=sprintf('heart_data_mapper_images_point/%s/%s/%s',filtername,Paras{zeta},fname);
system(commd);
imshow(file_with_location);

end
end
end
end
