%% All param
%FilterSamplesSizes={3;5;10;15;20;25;30}
FilterSamplesSizes={10}

%ovarlapPctBucket={25;50;75}
ovarlapPctBucket={50}
%for zeta=1:14
for distance_measure=2
for zeta=1
%for myfilter=1:2    
for myfilter=1
for alpha=1:length(FilterSamplesSizes)    
for beta=1:length(ovarlapPctBucket)
    
Paras={'age';'sex';'cp';'trestbps';'chol';'fbs';'restecg';'thalach';'exang';'oldpeak';'slope';'ca';'thal';'survival'}

%% Generate a matrix from heart dataset
load heart_matrix;
X = YO; 
%% Find the Inter-point Distance Matrix
if(distance_measure==1)
    d = mydistance(X,X);
    distance_measure_name='NORM_L2'
elseif(distance_measure==2)
    X=normalize_columns(X);
    d = corr(X');
    distance_measure_name='PEARSON'
end

%% Find the filter, here we use the distance from the first point
if(myfilter==1)
    
    eccFilter = max(d(:,1:length(X)))';
    filtername='L_INF';
elseif(myfilter==2)
    eccFilter = (X(:,zeta))';
    filtername='SINGLE_FEATURE'
elseif(myfilter==3)
    eccFilter = d(1,:);
    filtername='SINGLE_P'
else
     
    eccFilter = d(:, zeta);
    filtername='Pearson';
end
%scatter(X(:,1), X(:,2), 1000, eccFilter, '.');
%axis equal;

%% Parameters for Mapper
filterSamples = FilterSamplesSizes{alpha};
overlapPct = ovarlapPctBucket{beta};

%% Run Mapper
if((myfilter~=2 & zeta==1) | (myfilter==2))
	[adja, nodeInfo, levelIdx] = mapper(d, eccFilter, 1/filterSamples,...
		                                                   overlapPct);
		                                    
	%% Prepare inputs for GraphViz
	% For each node of the output graph, find the size (~ cardinality of the
	% cluster) and the average function value of points in the cluster.
	label{1} = sprintf('Dataset Name   : HeartDieseaseData');
	label{2} = sprintf('Filter Samples : %d', filterSamples);
	label{3} = sprintf('Overlap Pct    : %0.2f', overlapPct);

	for i=1:length(nodeInfo)
	    ecc(i) = nodeInfo{i}.filter;    
	    setSize(i) = length(nodeInfo{i}.set);
	    z=i
	    a = nodeInfo{i}.set
	end

	%% Generate the input to Graphviz
	writeDotFile(sprintf('/media/deepak/extension/matlab/tda/matlab_examples/mapper/t1.dot'), adja, ecc, setSize, label);
end
%% Execute Graphviz
if(myfilter~=2)
	if(zeta==1)
		filterstr=sprintf('%s',filtername);
		fname=sprintf('%s_%d_%d.png',filterstr,filterSamples,beta);

		filterdir1=sprintf('new/%s',distance_measure_name);
		mkdir(filterdir1)

		filterdir2=sprintf('new/%s/%s',distance_measure_name,filtername);
		mkdir(filterdir2)
		paramdir=sprintf('new/%s/%s/%d',distance_measure_name,filtername,beta);
		mkdir(paramdir)
		commd=sprintf('/usr/bin/neato -Tpng t1.dot -o new/%s/%s/%d/%s',distance_measure_name,filtername,beta,fname);
		file_with_location=sprintf('new/%s/%s/%d/%s',distance_measure_name,filtername,beta,fname);
		system(commd);
		imshow(file_with_location);
	end
else
	filterstr=sprintf('%s_%s',filtername,Paras{zeta});
	fname=sprintf('%s_%d_%d.png',filterstr,filterSamples,beta);
	
	
	filterdir1=sprintf('new/%s',distance_measure_name);
	mkdir(filterdir1)

	filterdir2=sprintf('new/%s/%s',distance_measure_name,filtername);
	mkdir(filterdir2)
	
	filterdirbase=sprintf('new/%s/%s/%s',distance_measure_name,filtername,Paras{zeta});
	mkdir(filterdirbase)
	
	paramdir=sprintf('new/%s/%s/%s/%d',distance_measure_name,filtername,Paras{zeta},ovarlapPctBucket{beta});
	mkdir(paramdir)
	commd=sprintf('/usr/bin/neato -Tpng t1.dot -o new/%s/%s/%s/%d/%s',distance_measure_name,filtername,Paras{zeta},ovarlapPctBucket{beta},fname);
	file_with_location=sprintf('new/%s/%s/%s/%d/%s',distance_measure_name,filtername,Paras{zeta},ovarlapPctBucket{beta},fname);
	system(commd);
	imshow(file_with_location);
end

end
end
end
end
end
